package edu.ntua.ivml.common.lp;

public class Function extends Functional  {

	public Function(String name, int arity) {
		super(name, arity);
	}
	
	public boolean equals(Object obj) {
		if (!(obj instanceof Function)) {
			return false;
		} else {
			return name.equals(((Function)obj).getName()) && arity == ((Function)obj).getArity();
		}
	}
	
	public int hashCode() {
		if (name != null) {
			return name.hashCode() + arity;
		} else {
			return 0;
		}
	}
	
	public int compareTo(Function p) {
		
		int nc = name.compareTo(p.getName());
		if (nc != 0) {
			return nc;
		} else {
			if (arity < p.getArity()) {
				return -1;
			} else if (arity > p.getArity()) {
				return 1;
			} else {
				return 0;
			}
		}
	}	
}
