package edu.ntua.ivml.qa.algorithm.rapid;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import edu.ntua.ivml.common.lp.Atom;
import edu.ntua.ivml.common.lp.Clause;

public class FlattenerExtra {
	protected Set<Clause> elClausesSet;
	protected ArrayList<Clause> elClausesArray;
	protected ArrayList<Boolean> elClausesState;
	protected ArrayList<ArrayList<Atom>> elClausesAtoms;

	public FlattenerExtra() {
		elClausesSet = new HashSet<>();
		elClausesArray = new ArrayList<>();
		elClausesState = new ArrayList<>();
		elClausesAtoms = new ArrayList<>();
	}
	
	public void setState(boolean s) {
		for (int i = 0; i < elClausesState.size(); i++) {
			elClausesState.set(i, s);
		}
	}
	
	public ArrayList<Clause> getExtraClauses() {
		return elClausesArray;
	}

	public void add(Clause nc) {
		if (elClausesSet.add(nc)) {
			elClausesArray.add(nc);
			elClausesState.add(true);
			elClausesAtoms.add(null);
		}
	}
	
	public void add(Clause nc, boolean s) {
		if (elClausesSet.add(nc)) {
			elClausesArray.add(nc);
			elClausesState.add(s);
			elClausesAtoms.add(null);
		}
	}
	
	public void add(Clause nc, boolean s, ArrayList<Atom> atoms) {
		if (elClausesSet.add(nc)) {
			elClausesArray.add(nc);
			elClausesState.add(s);
			elClausesAtoms.add(atoms);
		}
	}
	
	public void add(FlattenerExtra extra) {
		for (int i  = 0; i < extra.size(); i++) {
			add(extra.getClauseAt(i), extra.getStateAt(i), extra.getAtomsAt(i));
		}
	}
	
	public boolean contains(Clause nc) {
		return elClausesSet.contains(nc);
	}
	
	public int size() {
		return elClausesArray.size();
	}
	
	public Clause getClauseAt(int i) {
		return elClausesArray.get(i);
	}

	public boolean getStateAt(int i) {
		return elClausesState.get(i);
	}

	public ArrayList<Atom> getAtomsAt(int i) {
		return elClausesAtoms.get(i);
	}
}
