package edu.ntua.ivml.qa.algorithm.rapid;

import edu.ntua.ivml.common.lp.Clause;
import edu.ntua.ivml.common.lp.ClauseWrapper;

public class MarkedClause implements ClauseWrapper {
	private Clause clause;
	private int mark;
	
	public MarkedClause(Clause clause, int mark) {
		this.clause = clause;
		this.mark = mark;
	}
	
	public Clause getClause() {
		return clause;
	}
	
	public int getMark() {
		return mark;
	}
	
	public String toString() {
		return mark + " " + clause;
	}

	public <U extends ClauseWrapper> boolean isCCSubsumedBy(U u) {
		return clause.isCCSubsumedBy(u.getClause());
	}
	
	public int hashCode() {
		return clause.hashCode();
	}
	
	public boolean equals(Object obj) {
		if (obj instanceof MarkedClause) {
			return clause.equals(((MarkedClause)obj).clause);
		} else {
			return false;
		}
	}

}
