package edu.ntua.ivml.qa.algorithm.rapid;

import java.util.Collection;
import java.util.Set;

import edu.ntua.ivml.common.lp.Atom;
import edu.ntua.ivml.common.lp.Substitution;
import edu.ntua.ivml.common.lp.Term;
import edu.ntua.ivml.common.lp.Variable;


public class ProperRenamedAtom {
	private Substitution subst;
	private Atom renamedAtom;
	
	public ProperRenamedAtom(Atom atom, Collection<? extends Term> boundTerms) {
		Term[] terms = atom.getArguments().getTerms();
		
		Variable[] tuple = new Variable[atom.getPredicate().getArity()];
		subst = new Substitution();
	
		for (int i = 0; i < tuple.length; i++) {
			if (boundTerms.contains(terms[i])) {
				tuple[i] = (Variable)Rapid.dummyVars.get(i);
			} else {
				tuple[i] = Rapid.fixedUnboundVars[i];
			}
			
			if (!tuple[i].equals(terms[i])) {
				subst.put(tuple[i], terms[i]);
			}
		}
		
		renamedAtom = new Atom(atom.getPredicate(), tuple);
	}
	
	public Atom getRenamedAtom() {
		return renamedAtom;
	}
	
	public Substitution getSubstitution() {
		return subst;
	}
	
	public String toString() {
		return " < " + subst + " > " + renamedAtom;   
	}
}