package edu.ntua.ivml.qa.algorithm.rapid.dllite;

import edu.ntua.ivml.common.lp.Atom;
import edu.ntua.ivml.qa.algorithm.rapid.AtomUnfolding;
import edu.ntua.ivml.qa.algorithm.rapid.FunctionMap;


public class DLAtomUnfolding extends AtomUnfolding {
	private Atom[] unfoldings;
	
	public boolean[] mark;

	// unfoldings array must be sorted by Atom.PredicateComparator
	public DLAtomUnfolding(Atom[] unfoldings, FunctionMap[] argFunctions) {
		super(argFunctions);

		this.unfoldings = unfoldings;
	}

	public Atom[] getUnfoldings() {
		return unfoldings;
	}

	public void remove(Atom atom) {
		for (int i = 0; i < unfoldings.length; i++) {
			if (atom.equals(unfoldings[i])) {
				Atom[] newUnfoldings = new Atom[unfoldings.length - 1];
				System.arraycopy(unfoldings, 0, newUnfoldings, 0, i);
				System.arraycopy(unfoldings, i + 1, newUnfoldings, i, unfoldings.length - i - 1);
				unfoldings = newUnfoldings; 
				break;
			}
		}
	}
		
	public String toString() {
		String s = "";
		for (Atom a : unfoldings) {
			if (s.length() > 0) {
				s += ", ";
			}
			s += a;
		}
		s = "(" + argFunctions[0] + ", " + argFunctions[1] + ") : [" + s + "]"; 

		return s;
	}

	
}
