package edu.ntua.ivml.qa.algorithm.rapid.elhi;

import java.util.HashSet;
import java.util.Set;
import java.util.TreeSet;

import edu.ntua.ivml.common.lp.Atom;
import edu.ntua.ivml.common.lp.Term;
import edu.ntua.ivml.common.lp.Variable;


public class NamedAtomList {
	private String prefix;
	private String index;
	
	private Set<Atom> atoms;
	private Set<Term> terms;
	private Set<Variable> vars;
	
	public NamedAtomList(String prefix) {
		this.prefix = prefix;
		
		this.atoms = new TreeSet<Atom>();
		this.terms = new HashSet<Term>();
		this.vars = new HashSet<Variable>();
	}
	
	public void add(Atom a) {
		atoms.add(a);
		terms.addAll(a.getTerms());
		vars.addAll(a.getVariables());
	}
	
	public String getPrefix() {
		return prefix;
	}

	public String getIndexedPrefix() {
		return index + prefix;
	}

	public void setIndex(int i) {
		this.index = i + "";
	}
	
	public Set<Atom> getAtoms() {
		return atoms;
	}
	
	public Set<Term> getTerms() {
		return terms;
	}
	
	public Set<Variable> getVariables() {
		return vars;
	}

}
