package edu.ntua.ivml.qa.graph;

import edu.ntua.ivml.common.lp.Substitution;
import edu.ntua.ivml.common.lp.Term;

public class DirectedEdge<T extends Term> {
	public T n1, n2;
	
	public DirectedEdge(T n1, T n2) {
		this.n1 = n1;
		this.n2 = n2;
	}
	
	public DirectedEdge<T> apply(Substitution s) {
		return new DirectedEdge(n1.apply(s), n2.apply(s));
	}
	
	public T getP1() {
		return n1;
	}

	public T getP2() {
		return n2;
	}

	public int hashCode() {
		return n1.hashCode() + n2.hashCode();
	}
	
	public boolean equals(Object obj) {
		if (!(obj instanceof DirectedEdge)) {
			return false;
		}
		
		DirectedEdge<T> e2 = (DirectedEdge<T>)obj;
		
		return e2.n1.equals(n1) && e2.n2.equals(n2);
	}
	
	public String toString() {
		return n1 + "-" + n2;
	}
}