package edu.ntua.ivml.qa.rewriting;

import edu.ntua.ivml.common.lp.Clause;
import edu.ntua.ivml.common.lp.ClauseWrapper;

public class OrderedClause implements ClauseWrapper {
	private Clause clause;
	private int order;
	
	public OrderedClause(Clause clause, int order) {
		this.clause = clause;
		this.order = order;
	}
	
	public boolean isTop() {
		return order == 0;
	}
	
	public int getOrder() {
		return order;
	}
	
	public Clause getClause() {
		return clause;
	}

	public <U extends ClauseWrapper> boolean isCCSubsumedBy(U c) {
		return clause.isCCSubsumedBy(c.getClause());
	}
	
	public String toString() {
		return clause.toString();
	}
	
}
